class Thermostat
  attr_accessor :current_value, :want_value, :range, :heating, :airco, :unit

  def initialize(want_value = 0, range = 0, unit = 'celsius', current_value = 0)
    @current_value = current_value
    @want_value = want_value
    @range = range / 2
    @unit = unit
  end

  def celsius_to_kelvin
    @current_value += 273.15
  end

  def celsius_to_fahrenheit
    @current_value = (@current_value * 1.8) + 32
  end

  def kelvin_to_celsius
    @current_value -= 273.15
  end

  def kelvin_to_fahrenheit
    @current_value = (@current_value - 273.15 * 1.8) + 32
  end

  def fahrenheit_to_celsius
    @current_value = (@current_value - 32) / 1.8
  end

  def fahrenheit_to_kelvin
    @current_value = ((@current_value - 32) / 1.8) + 273.15
  end

  def heat
    @heating = true
    @airco = false
    puts 'Heat will be turned on.'
  end

  def cool
    @heating = false
    @airco = true
    puts 'Airco will be turned on.'
  end

  def all_off
    @heating = false
    @airco = false
    puts 'Perfect temperature'
  end

  def check_unit(sensor_unit)
    check_if_unit_to_celsius(sensor_unit)
    check_if_unit_to_fahrenheit(sensor_unit)
    check_if_unit_to_kelvin(sensor_unit)
  end

  def check_if_unit_to_celsius(sensor_unit)
    check_if_unit_is_fahrnheit_to_celsius(sensor_unit) if @unit == 'celsius'
    check_if_unit_is_kelvin_to_celsius(sensor_unit) if @unit == 'celsius'
  end

  def check_if_unit_to_kelvin(sensor_unit)
    check_if_unit_is_fahrenheit_to_kelvin(sensor_unit) if @unit == 'kelvin'
    check_if_unit_is_celsius_to_kelvin(sensor_unit) if @unit == 'kelvin'
  end

  def check_if_unit_to_fahrenheit(sensor_unit)
    check_if_unit_is_celsius_to_fahrenheit(sensor_unit) if @unit == 'fahrenheit'
    check_if_unit_is_kelvin_to_fahrenheit(sensor_unit) if @unit == 'fahrenheit'
  end

  def check_if_unit_is_fahrnheit_to_celsius(sensor_unit)
    fahrenheit_to_celsius if sensor_unit == 'fahrenheit'
  end

  def check_if_unit_is_kelvin_to_celsius(sensor_unit)
    kelvin_to_celsius if sensor_unit == 'kelvin'
  end

  def check_if_unit_is_celsius_to_kelvin(sensor_unit)
    celsius_to_kelvin if sensor_unit == 'celsius'
  end

  def check_if_unit_is_fahrenheit_to_kelvin(sensor_unit)
    fahrenheit_to_kelvin if sensor_unit == 'fahrenheit'
  end

  def check_if_unit_is_kelvin_to_fahrenheit(sensor_unit)
    kelvin_to_fahrenheit if sensor_unit == 'kelvin'
  end

  def check_if_unit_is_celsius_to_fahrenheit(sensor_unit)
    celsius_to_fahrenheit if sensor_unit == 'celsius'
  end

  def it_in_range
    if (@current_value - @want_value).abs > @range
      check_heat
      check_cool
    else
      all_off
    end
  end

  def check_heat
    heat if @current_value < @want_value
  end

  def check_cool
    cool if @current_value > @want_value
  end

  def run(sensor_unit)
    check_unit(sensor_unit)
    it_in_range
  end
end
